import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;

/**
 * Recipe.java
 *
 *
 * Created: Wed May  13 15:29:12 2002
 *
 *
 * @author<br/> 
 * Cristian Barreca, Elena Bonessa and Antonella Borra</br>
 * Modified by:</br>
 * Marco Lamieri and Francesco Merlo
 * @version 0.9.7.31.b
 */

/**This class is used to record the recipes and their referring number (ID), so we can assign them to a List*/ 
public class Recipe extends SwarmObjectImpl{
    //INSTANCE VARIABLES
    /**the array containing the recipe*/ 
    int[] orderRecipe;
    
    /**the referring number of the recipe in the worksheet file*/
    int code;
    
    /**The length of the array
     */
    int length;
    
    /**Flags to operate checks while reading 
     */
    public String semicolon = ";", checkTheCell, gate = "#", p = "p", end = "e",
    	sec = "s", min = "m", slash = "/", backslash = "\\", or = "||",
    	computation="c";
    /** The name of the recipe
     */
    String recipeName;

    /** the dictionary to be used to choose the steps to be included in 
     *    a recipe 
     */
    int[] dictionary;
    
    /** length of the dictionary */
    int dictionaryLength;
    
    OrderDistiller orderDistiller;
    
    int j, choice, step;
    //CONSTRUCTOR
    public Recipe(Zone aZone, int c, int l, String rN){
	
	super(aZone);
	
	code = c;
	orderRecipe = new int[l];
	for(int j = 0; j < l; j++)orderRecipe[j] = 0;
	length = l;
	recipeName = rN;
    }
    
    public int getCodeNumber(){
	
	return code;
	
    }
    
    public int[] getOrderRecipe(){
	
	return orderRecipe;
	
    }
    
    public int getLength(){
	
	return length;
	
    }
    
    public String getRecipeName(){

	return recipeName;

    }

    public void setSteps(String cTC, ExcelReader recipeWorksheet){

	
	checkTheCell = cTC;

	checkTheCell = recipeWorksheet.getStrValue();
	j = 0;
	if(StartESFrame.verbose)
	System.out.println(checkTheCell +" The length of the recipe n " + getCodeNumber() + " is " + getLength());

	while(! checkTheCell.equals(semicolon)){
	    if(checkTheCell.equals(p))   choice = 1;
	    if(checkTheCell.equals(or))  choice = 2;
	    if(checkTheCell.equals(end)) choice = 3;
	    if(checkTheCell.equals(computation)) choice = 4;
	    if(recipeWorksheet.checkForLabelCell() && !checkTheCell.equals(semicolon))   choice = 5;
	  
	    switch(choice){
	    case 1:
			if(StartESFrame.verbose)
				System.out.println("Recipe: the choice is for a Procurement");
			procurement(recipeWorksheet);
		break;
	    case 2:
			if(StartESFrame.verbose)
				System.out.println("Recipe: the choice is for an Or ");
			oR(recipeWorksheet);
		break;
	    case 3:
			if(StartESFrame.verbose)
				System.out.println("Recipe: the choice is for an End ");
			end(recipeWorksheet);
		break;
		case 4:
			if(StartESFrame.verbose)
				System.out.println("Recipe: the choice is for a Computation ");
			computation(recipeWorksheet);
		break;
	    case 5:
			if(StartESFrame.verbose)
				System.out.println("Recipe: the choice is for a Number");
			number(recipeWorksheet);
		break;
	    default:
	if(StartESFrame.verbose)
		System.out.println("Recipe: no matches were found reading the worksheet, check for errors inside it");
		System.exit(1);


	    }
	}
	
	for(int h = 0; h < length; h++)
	    if(StartESFrame.verbose)
	    System.out.println("The recipe contains " + orderRecipe[h] + " in position " + h); 
	if(! recipeWorksheet.eof())
	    checkTheCell = recipeWorksheet.getStrValue();

    }          
    
    public String getCheckTheCell(){
	
	return checkTheCell;
	
    }
    
    /**This method is used to check if a type error occur
     */
    public int errorIsNotAnInteger(ExcelReader e){
	
	if(e.checkForLabelCell())
	    {
		if(StartESFrame.verbose)
		System.out.println("The cell should contain an Integer Value");
		System.exit(1);
	    }
	return e.getIntValue();
    }
    
    /**This method is used to check if a type error occur
     */
    public void errorIsNotAString(ExcelReader e){
	
	if(e.checkForLabelCell());
	{
	    if(StartESFrame.verbose)
	    System.out.println("The cell should contain a String Value");
	    System.exit(1);
	}
    }
    
    /**This method dial with the computation choice
     */    
    public void computation(ExcelReader e){
	int numberMatrixesForComputation = 0;
	int computationCode, step;
	int [] matrixesForComputation;
	
	// Getting the computation code
	computationCode = e.getIntValue();	

	// Getting the number of matrixes used for computation
	numberMatrixesForComputation = e.getIntValue();
	
	// Creating an array with the name of matrixes
	matrixesForComputation = new int[numberMatrixesForComputation];

	// Getting the matrixes
	for(int m = 0; m < numberMatrixesForComputation; m++)
	    matrixesForComputation[m] = e.getIntValue();
	    
	// Getting the production step    
	step = e.getIntValue();
	
	// Getting the time unit
	checkTheCell = e.getStrValue();
	
	// Expanding the production step for intermediate format
	if(checkTheCell.equals(sec))
		second(e, step);
	else if(checkTheCell.equals(min))
		minute(e, step);
	else{ 
	    if(StartESFrame.verbose)
	    System.out.println("Time is not expressed in minutes or seconds. Check the worksheet");
	    System.exit(1);
	}	
	
	orderRecipe[++j] = -1 * computationCode;
	
	orderRecipe[++j] = numberMatrixesForComputation;

	for(int h = 0; h < numberMatrixesForComputation; h++)
	    orderRecipe[++j] = matrixesForComputation[h];

	orderRecipe[++j] = 1000000000 + step;

	j++;
	
    }    
    
    /**This method dial with the procurement choice
     */    
    public void procurement(ExcelReader e){
	int numberOfStepsForProcurement = 0;

	orderRecipe[j] = -1;
	numberOfStepsForProcurement = e.getIntValue();
	orderRecipe[++j] = numberOfStepsForProcurement;
	for(int h = 0; h < numberOfStepsForProcurement; h++)
	    orderRecipe[++j] = e.getIntValue();
	j++;
	checkTheCell = e.getStrValue();

    } 

    /**This method dial with the or choice
     */
    public void oR(ExcelReader e){

	orderRecipe[j] = -10;
	orderRecipe[++j] = e.getIntValue();
	j++;
	checkTheCell = e.getStrValue();

    }

    /**This method dial with the end choice
     */
    public void end(ExcelReader e){

	orderRecipe[j] = e.getIntValue();
	checkTheCell = e.getStrValue();

    }

    /**This method dial with normal or batch choice
     */
    public void number(ExcelReader e){
	
	step = Integer.parseInt(checkTheCell);
	checkTheCell = e.getStrValue();
	if(checkTheCell.equals(sec)) second(e, step);
	else if(checkTheCell.equals(min))minute(e, step);
	else{ 
	    if(StartESFrame.verbose)
	    System.out.println("Time is not expressed in minutes or seconds. Check the worksheet");
	    System.exit(1);
	}
	j++;
    }


    public void second(ExcelReader e, int step){ 
	int numberOfSteps = 0;

	numberOfSteps = e.getIntValue();
	    if(numberOfSteps == 0){
		checkTheCell = e.getStrValue();
		orderRecipe[j] = 1000000000 + step;
	    }
	    else { 
	    checkTheCell = e.getStrValue();
	    
	    if(checkTheCell.equals(slash) || checkTheCell.equals(backslash)){
		
		if(checkTheCell.equals(slash)){
		    orderRecipe[j] = -2;
		    orderRecipe[++j] = numberOfSteps;
		    orderRecipe[++j] = e.getIntValue();
		    orderRecipe[++j] = step;
		}			
		
		else if(checkTheCell.equals(backslash)){
		    orderRecipe[j] = -3;
		    orderRecipe[++j] = numberOfSteps;
		    orderRecipe[++j] = e.getIntValue();
		    orderRecipe[++j] = step;
		}
		checkTheCell = e.getStrValue();
	    }

	    else {
		orderRecipe[j] = step;
		for(int jj = 0; jj < numberOfSteps - 1; jj++)
		    orderRecipe[++j] = step;
	    }

	    }
    }

   public void minute(ExcelReader e, int step){ 
       int numberOfSteps = 0;
       
       numberOfSteps = e.getIntValue();
	    numberOfSteps = numberOfSteps * 60;
	    if(numberOfSteps == 0){
		checkTheCell = e.getStrValue();
		orderRecipe[j] = 1000000000 + step;
	    }
	    else { 
		checkTheCell = e.getStrValue();
		
		if(checkTheCell.equals(slash) || checkTheCell.equals(backslash)){
		    
		    if(checkTheCell.equals(slash)){
			orderRecipe[j] = -2;
			orderRecipe[++j] = numberOfSteps;
			orderRecipe[++j] = e.getIntValue();
			orderRecipe[++j] = step;
		    }			
		    
		    else if(checkTheCell.equals(backslash)){
			orderRecipe[j] = -3;
			orderRecipe[++j] = numberOfSteps;
			orderRecipe[++j] = e.getIntValue();
		    orderRecipe[++j] = step;
		    }
		    checkTheCell = e.getStrValue();
		}

		else {
		orderRecipe[j] = step;
		for(int jj = 0; jj < numberOfSteps - 1; jj++)
		    orderRecipe[++j] = step;
	    }
		
	    }
   }
    
}//Recipe.java
