import swarm.Globals;
import swarm.defobj.Zone;
import swarm.objectbase.SwarmObjectImpl;
import swarm.collections.ListImpl;
import java.io.*;
import java.util.*;

/**
 * we follow the InformationRuleMaster to deal with the news management
 *
 * @author Paolo Pelligra; IO improved by Michele Sonnessa
 */
public class InformationRuleMaster extends SwarmObjectImpl {

    /** the number of the unit which is calling the InformationRuleMaster,
	to send a news */
    public int sendingUnit;
    /** the number of the unit to which we have to send a news */
    public int receivingUnit;
    /** the matrix containing the rules to manage the information flow */
    public int [][] informationFlowMatrix;

    /**
     * constructor for InformationRuleMaster
     */
    public InformationRuleMaster (Zone aZone, int un)
    {

	// call the constructor for the parent class
	super(aZone);
        int i;
        int j;
	int unitNumber = un;
        String line=null;

	//DataInputStream data=null;
	BufferedReader data = null;

	informationFlowMatrix = new int[unitNumber][unitNumber];

	// read the informationFlowMatrix file and assign the values
	// to the informationFlowMatrix matrix

	try{
	    data = new BufferedReader(new
		FileReader("unitData/informationFlowMatrix.txt"));
	} 
	catch (FileNotFoundException fnfe)
	    {
		System.out.println(fnfe);
		MyExit.exit(1);
	    }

        if(StartESFrame.verbose)
	    System.out.println
		("informationFlowMatrix " 
		 + unitNumber + " x "  + unitNumber);
	for (i=0;i<unitNumber;i++)
	    {
		try
		    {
			line=data.readLine();
			if(line==null){
			    System.out.println("Missing rows in "+
				       "unitData/informationFlowMatrix.txt");
			    MyExit.exit(1);
			}

			if(line.length()<unitNumber){
			 System.out.println(
			  "Error in file unitData/informationFlowMatrix.txt");
			 System.out.println(
			  "Length of row "+i+" < total unit number.");
         		 MyExit.exit(1);
			}
		    } 
		catch (IOException ioe) 
		    {
			System.out.println(ioe);
			MyExit.exit(1);
		    }

		for (j=0;j<unitNumber;j++)
		    {
			informationFlowMatrix [i][j] =
			    Integer.parseInt(line.substring(j,j+1));
			if(StartESFrame.verbose)
			    System.out.print(+informationFlowMatrix[i][j]+" ");
		    }
		if(StartESFrame.verbose)System.out.println();
	    }
    }

    /** the sending unit checks if the information flow to the receiving
     *  unit is or not open
     */
    public boolean checkToSendNews(int s, int r)
    {
	sendingUnit=s;
	receivingUnit=r;

	if(StartESFrame.verbose)
	    System.out.println(" the unit # " + sendingUnit +
			       " is checking the informationRuleMaster");
        if (informationFlowMatrix[sendingUnit-1][receivingUnit-1]==1)
	    {
		if(StartESFrame.verbose)
		    System.out.println("the unit # " + sendingUnit +
		    " can send a news to the unit # "
		    + receivingUnit + " (informationFlowMatrix value= "
		    + informationFlowMatrix[sendingUnit-1][receivingUnit-1]
		    + ")");
		return true;
	    }
        else
	    {
		if(StartESFrame.verbose)
		    System.out.println("the unit # " + sendingUnit +
	              " cannot send a news to unit # " + receivingUnit +
		      " (informationFlowMatrix value= "
                      + informationFlowMatrix[sendingUnit-1][receivingUnit-1]
		      + ")");
		return false;
	    }
    }
}



